import { Type } from "./type";
/**
 * Describes available positions on the Y axis at which the summary tooltip to be displayed.
 */
export declare enum DataTooltipGroupedPositionY {
    /**
     * A position on the Y axis is selected automatically.
     */
    Auto = 0,
    /**
     * Aligns the tooltip so that it appears at the top of the vertical snap point of the current series if applicable.
     */
    SnapTop = 1,
    /**
     * Aligns the tooltip so that it appears at the bottom of the vertical snap point of the current series if applicable.
     */
    SnapBottom = 2,
    /**
     * Aligns the tooltip so that it appears at the middle of the vertical snap point of the current series if applicable.
     */
    SnapMiddle = 3,
    /**
     * Aligns the tooltip so that it appears at the top of the vertical snap point of the current series if applicable.
     */
    TopEdgeSnapTop = 4,
    /**
     * Aligns the tooltip so that it appears at the bottom of the vertical snap point of the current series if applicable.
     */
    TopEdgeSnapBottom = 5,
    /**
     * Aligns the tooltip so that it appears at the middle of the vertical snap point of the current series if applicable.
     */
    TopEdgeSnapMiddle = 6,
    /**
     * Aligns the tooltip so that it appears at the top of the vertical snap point of the current series if applicable.
     */
    BottomEdgeSnapTop = 7,
    /**
     * Aligns the tooltip so that it appears at the bottom of the vertical snap point of the current series if applicable.
     */
    BottomEdgeSnapBottom = 8,
    /**
     * Aligns the tooltip so that it appears at the middle of the vertical snap point of the current series if applicable.
     */
    BottomEdgeSnapMiddle = 9,
    /**
     * Aligns the tooltip so that it appears at the top of the cursor.
     */
    TrackTop = 10,
    /**
     * Aligns the tooltip so that it appears at the bottom of the cursor.
     */
    TrackBottom = 11,
    /**
     * Aligns the tooltip so that the cursor appears in the center of the tooltip height.
     */
    TrackMiddle = 12,
    /**
     * Aligns the tooltip relative to the top chart edge.
     */
    PinTop = 13,
    /**
     * Aligns the tooltip relative to the bottom chart edge.
     */
    PinBottom = 14,
    /**
     * Aligns the tooltip height center with the height center of the chart.
     */
    PinMiddle = 15
}
/**
 * @hidden
 */
export declare let DataTooltipGroupedPositionY_$type: Type;
